User Function AjusteTranProd()
Local aVetor := {}
Local aEmpen := {}
Local nOpc		// 3 - Inclusao 4 - Alteracao 5 - Exclusao
Local nQuant
Local i
Private pCodOrig	:= 1
Private pDesOrig	:= 2
Private pUnMOrig	:= 3
Private pArmOrig	:= 4
Private pCodDest	:= 6
Private pDesDest	:= 7
Private pUnMDest	:= 8
Private pArmDest	:= 9
Private pD3Quant	:= aScan(aHeader, {| aVet | PadR(aVet[2], 10) == "D3_QUANT  "})
Private pD3QtSegUm	:= aScan(aHeader, {| aVet | PadR(aVet[2], 10) == "D3_QTSEGUM"}) 
Private pD3Estorno	:= aScan(aHeader, {| aVet | PadR(aVet[2], 10) == "D3_ESTORNO"})
Private pD3ZZOPOri	:= aScan(aHeader, {| aVet | PadR(aVet[2], 10) == "D3_ZZOPORI"})
Private lMsErroAuto := .F.

	ProcRegua(Len(aCols))

	DbSelectArea('SD4')
	SD4->(DbSetOrder(2)) // D4_FILIAL+D4_OP+D4_COD+D4_LOCAL                                                                                                                                 
	for i := 1 to Len(aCols)
		IncProc()

		// Procura pelo empenho no armazem de origem e altera a quantidade
		if ( SD4->(DbSeek(XFilial('SD4')+cOPTrans+aCols[i, pCodOrig]+aCols[i, pArmOrig])) )
			if ( SD4->D4_QtdeOri <= aCols[i, pD3Quant] )
				nOpc	:= 5
				nQuant	:= SD4->D4_QtdeOri
			else
				nOpc	:= 4
				nQuant	:= SD4->D4_QtdeOri - aCols[i, pD3Quant]
			endif

			aVetor	:= {	{"D4_COD"     ,aCols[i, pCodOrig]	,Nil},; //COM O TAMANHO EXATO DO CAMPO
							{"D4_LOCAL"   ,aCols[i, pArmOrig]	,Nil},;
							{"D4_OP"      ,cOPTrans				,Nil},;
							{"D4_DATA"    ,dDataBase			,Nil},;
							{"D4_QUANT"   ,nQuant				,Nil},;
							{"D4_QTDEORI" ,nQuant				,Nil},;
							{"D4_QTSEGUM" ,0					,Nil}}

			AADD(aEmpen,{	nQuant	,;	// SD4->D4_QUANT
							""		,;	// DC_LOCALIZ
							""		,;	// DC_NUMSERI
							0		,;	// D4_QTSEGUM
							.F.		})

			MSExecAuto({|x,y,z| mata380(x,y,z)},aVetor,nOpc,aEmpen) 

			if ( lMsErroAuto ) // Se ocorrer algum erro na alterao do empenho, vai para outro produto
			    MostraErro()
			    Aviso(Fundesc(),OemToAnsi('O produto '+AllTrim(aCols[i, pCodOrig])+' no teve seu empenho alterado, anote o cdigo e faa a alterao manualmente.'),{'Ok'})
			    Loop
			endif
		endif

		aVetor	:= {}
		aEmpen	:= {}
		// Procura pelo empenho no armazem de destino
		if ( SD4->(DbSeek(XFilial('SD4')+cOPTrans+aCols[i, pCodDest]+aCols[i, pArmDest])) )
			nOpc	:= 4
			nQuant	:= SD4->D4_QtdeOri + aCols[i, pD3Quant]
		else
			nOpc	:= 3
			nQuant	:= aCols[i, pD3Quant]
		endif

		aVetor	:= {	{"D4_COD"     ,aCols[i, pCodDest]	,Nil},; //COM O TAMANHO EXATO DO CAMPO
						{"D4_LOCAL"   ,aCols[i, pArmDest]	,Nil},;
						{"D4_OP"      ,cOPTrans				,Nil},;
						{"D4_DATA"    ,dDataBase			,Nil},;
						{"D4_QTDEORI" ,nQuant				,Nil},;
						{"D4_QUANT"   ,nQuant				,Nil},;
						{"D4_TRT"     ,""					,Nil},;
						{"D4_QTSEGUM" ,0					,Nil}}

		AADD(aEmpen,{	nQuant	,;	// SD4->D4_QUANT
						""		,;	// DC_LOCALIZ
						""		,;	// DC_NUMSERI
						0		,;	// D4_QTSEGUM
						.F.		})

		MSExecAuto({|x,y,z| mata380(x,y,z)},aVetor,nOpc,aEmpen) 

		if ( lMsErroAuto )
		    MostraErro()
		    Aviso(Fundesc(),OemToAnsi('O produto '+AllTrim(aCols[i, pCodOrig])+' no teve seu empenho gerado, anote o cdigo e gere o empenho manualmente.'),{'Ok'})
		endif
	next
return
